/*  reader-writer.c (Praktikum, Arbeitsblatt 7)

    Vorlesung Betriebssysteme
    Hans-Georg Eer, Hochschule Mnchen
    hans-georg.esser@hm.edu

    basiert auf Code aus http://www.thinkbrown.com/programming/pthreads.pdf
    (Seite 4/5)
*/

#include <pthread.h>
#include <stdio.h>                     // fuer printf()
#include <unistd.h>                    // fuer usleep()

char buffer;                           // Buffer der Groesse 1
int buffer_has_item = 0;               // Buffer am Anfang leer
pthread_mutex_t mutex;                 // Mutex fuer Zugriff auf Buffer

int make_new_item() { return 0; };     // neues Item erzeugen
void consume_item (int i) { return; }; // Item verbrauchen

void writer_function(void) {           // Erzeuger
  while(1) {
    pthread_mutex_lock( &mutex );
    if ( buffer_has_item == 0 ) {
      buffer = make_new_item();
      buffer_has_item = 1; }
    pthread_mutex_unlock( &mutex );
    usleep(100);                       // 100 msec warten
  }
}

void reader_function(void) {           // Verbraucher
  while(1) {
    pthread_mutex_lock( &mutex );
    if ( buffer_has_item == 1 ) {
      consume_item( buffer );
      printf ( "%d \n",buffer );       // Lebenszeichen ausgeben
      buffer_has_item = 0; }
    pthread_mutex_unlock( &mutex );
    usleep(100);                       // 100 msec warten
  }
}

main() {
  pthread_t reader;
  pthread_mutex_init(&mutex, NULL);    // Mutex initialisieren
                                       // ein neuer Thread: Erzeuger
  pthread_create( &reader, NULL, (void*)&reader_function, NULL);
  writer_function();                   // Verbraucher im Haupt-Thread
}
